Dim iT
Dim updateDelay
Dim iTimerID
Dim freeze

  sub HideFlyout(strChoice)
    System.Gadget.Flyout.show = false
	
	if strChoice = "yes" then      
	  MachineShutdown(System.Gadget.Settings.readString("action"))
	end if
  end sub  

  sub MachineShutdown(strAction)
	select case strAction
		case "shutdown"
			actionCode = 1
		case "log off"
			actionCode = 0
		case "restart"
			actionCode = 2
		case "switch user"
			actionCode = -1
	end select
	
	//
	// Process shutdown, log off, and restart
	//
	if actionCode <> -1 then
		System.Gadget.document.getElementById("command").innerHTML = "Processing " + System.Gadget.Settings.readString("action")

		set OpSysSet = GetObject("winmgmts:{impersonationLevel=impersonate,(Shutdown)}//" & mname).ExecQuery(_
			"select Name from Win32_OperatingSystem where Primary=true")
			
		for each OpSys in OpSysSet
			OpSys.Win32Shutdown(actionCode)
		next	
	//
	// Process switch user.
	//
	else
		System.Shell.execute System.Gadget.path + "\\shift.exe", "switchuser"
		System.Gadget.document.getElementById("command").innerHTML = ""	
	end if	
end sub    

sub processCmd(cmd) 
	select case cmd 
		case 1:
			System.Gadget.Settings.writeString "action", "shutdown" 
		case 2:
			System.Gadget.Settings.writeString "action", "restart" 
		case 3:
			System.Gadget.Settings.writeString "action", "log off" 
		case 4:
			System.Gadget.Settings.writeString "action", "switch user" 
	end select
	
	System.Gadget.Flyout.show = true	
end sub

sub alterLogo(cmd) 
	if freeze = flase then
		select case cmd
			case 0:
				logo.src = "gfx/vista logo.png"
				command.InnerHTML=""
			case 1:
				logo.src = "gfx/orange.png"
				command.InnerHTML = "Shutdown"
			case 2:
				logo.src = "gfx/green.png"
				command.InnerHTML = "Restart"
			case 3:
				logo.src = "gfx/blue.png"
				command.InnerHTML = "Log Off"
			case 4:
				logo.src = "gfx/yellow.png"
				command.InnerHTML = "Switch User"
		end select
	end if
end sub

sub prep() 
	freeze = false
	//
	// Prep the flyout window
	//
	System.Gadget.Flyout.file = "confirmation.html"
	command.InnerHTML=""

	updateDelay = 10
	iT = window.SetInterval("InitServiceSystem '" & now & "'", 1000) 
end sub

sub InitServiceSystem(startTime)
	timeRunning = DateDiff("s", startTime, now)
	
	if timeRunning >= updateDelay then
		window.clearInterval(iT)

		Set bd = CreateObject("WbemScripting.SWbemDateTime")
		Set objLocator = CreateObject("WbemScripting.SwbemLocator")
		Set objWMIService = objLocator.ConnectServer(".", "root\cimv2")
		Set colOperatingSystems = objWMIService.ExecQuery ("Select * from Win32_OperatingSystem")
	
		For Each objOperatingSystem in colOperatingSystems
			bd = objOperatingSystem.LastBootUpTime
		Next	

		mn = mid(bd, 5, 2)
		d = mid(bd, 7, 2)	
		y = left(bd, 4)
		h = mid(bd, 9, 2)
		m = mid(bd, 11, 2)
		s = mid(bd, 13, 2)
		
		bt = mn & "/" & d & "/" & y
		bt = bt & " "  & h & ":" & m & ":" & s
		
		UpTime(bt)
		iTimerID = window.SetInterval("UpTime('" & bt & "')", 1000)
	end if      
end sub

sub UpTime(BootTime)
	ct = now
	btS = DateDiff("s", BootTime, ct)
	
	days = int(btS / 24 / 60 / 60)
	bts = btS - (days * 24 * 60 * 60)
	
	hours = int(btS / 60 / 60)
	btS = btS - (hours * 60 * 60)
	
	minutes = int(btS / 60)
	btS = btS - (minutes * 60)
	
	seconds = btS
	
	days = Right(String(2,"0") & days, 2)
	hours = Right(String(2,"0") & hours, 2)
	minutes = Right(String(2,"0") & minutes, 2)
	seconds = Right(String(2,"0") & seconds, 2)

	if StrComp((left(SystemUpTime.InnerHTML, 6)), "Proces") <> 0 then
		SystemUpTime.InnerHTML = "Uptime: " & days & ":" & hours & ":" & minutes & ":" & seconds
	end if
end sub